package pro.skywalking.utils;

import org.apache.commons.lang3.StringUtils;
import org.slf4j.MDC;
import pro.skywalking.http.NetworkUtils;
import pro.skywalking.utils.SnowflakeIdWorker;

public class MdcUtils {

   public static final String KEY_MSG_ID = "_GLOBAL_MSG_ID";
   private static final String KEY_IP = "IP";
   private static final String KEY_URL = "URL";
   private static String ip;
   private static String shotIp;


   public static void init() {
      MDC.clear();
      MDC.put("IP", ip);
   }

   public static void setIp() {
      MDC.put("IP", ip);
   }

   public static void setIp(String ip) {
      ip = ip;
      MDC.put("IP", ip);
      shotIp = NetworkUtils.shortIp(ip);
   }

   public static String getIp() {
      return ip;
   }

   public static void removeIp() {
      MDC.remove("IP");
   }

   public static String getShotIp() {
      return shotIp;
   }

   public static void setUrL(String url) {
      MDC.put("URL", url);
   }

   public static String getUrL() {
      return MDC.get("URL");
   }

   public static void removeUrL() {
      MDC.remove("URL");
   }

   public static void setMsgId(String id) {
      MDC.put("_GLOBAL_MSG_ID", id);
   }

   public static String getMsgId() {
      return MDC.get("_GLOBAL_MSG_ID");
   }

   public static void removeMsgId() {
      MDC.remove("_GLOBAL_MSG_ID");
   }

   public static String generateId(String ip) {
      StringBuilder sb = new StringBuilder(22);
      if(null == shotIp) {
         setIp(ip);
      }

      sb.append("wt_").append(getIp());
      sb.append("_").append(SnowflakeIdWorker.uniqueStringSequence());
      return sb.toString();
   }

   public static String setOrGenMsgId(String msgId, String ip) {
      if(StringUtils.isBlank(msgId)) {
         msgId = generateId(ip);
      }

      setMsgId(msgId);
      return msgId;
   }

   public static String getOrGenMsgId(String ip) {
      String msgId = getMsgId();
      if(StringUtils.isBlank(msgId)) {
         msgId = generateId(ip);
         setMsgId(msgId);
      }

      return msgId;
   }

   public static void main(String[] args) {
      System.out.println(getOrGenMsgId("127.0.0.1"));
   }
}
